// DM9601.h: interface for the DM9601 class.
//
//////////////////////////////////////////////////////////////////////
//========================================================================
// Class Name	: DM9601
// Purpose		: 
// Autor		: Richard Chuang
// Email		: 
// Description	: 
// Reference    : 
// Copyright    : Copyright (c) 2000-2007 Davicom Inc.  All rights reserved.
// -----------------------------------------------------------------------
// Version		: 1.0.0.0
// Update       : 2007-12-19
// Modified		: Richard Chung
// Description	: 
// -----------------------------------------------------------------------
// How to use: 
// 
#if !defined(_DAVICOM_DM9601_H_)
#define _DAVICOM_DM9601_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "dm9usb.h"

//==============================================================================
#define DM9601_DRIVER_VERSION		_T("1.0.071219.601")		// Major.Minor.Release.Built
#define DM9601_RELEASE_DATE			_T("2007/12/19")	// YYYY/MM/DD
//==============================================================================
#define DM9601_CHIP_ID				0x96010A46			// ProductID VendorID


class DM9601 : public DM9USB  
{
public:
	//==========================================================================
	// Constructor/Destrcutor
	//==========================================================================
	virtual ~DM9601();
	DM9601(NIC_DRIVER_OBJECT *pUpper,PVOID pVoid);
	//==========================================================================
	// Member functions
	//==========================================================================
public:
	LPCTSTR	GetDriverVersion(void);
	LPCTSTR	GetReleaseDate(void);
	
protected:	
	DWORD	GetDriverChipID(void);

	//==========================================================================
	// Data Member
	//==========================================================================
public:
};

#endif // !defined(_DAVICOM_DM9601_H_)
